ComandInfo 			struct
     cOpCod    		dd ?         ;    
     cAdr      		db 6 DUP (?) ;    
     cData     		db 6 DUP (?) ;    
     cLen      		db ?         ;      (   )
     cALen     		db ?         ;     
 
     cDLen     		db ?         ;     
     cModRM    		db ?         ;    ModRM (1- 0-)
     cMod      		db ?         ;    Mod   (xx000000b)
     cRM       		db ?         ;    RM    (00000xxxb)
     cReg      		db ?         ;    Reg   (00xxx000b)
     cSIB      		db ?         ;    SIB   (1- 0-)
     cSibSS    		db ?         ;    Scale (xx000000b)
     cSibIndex 		db ?         ;    Index (00xxx000b)
     cSibBase  		db ?         ;    Base  (00000xxxb)
     cFlg_0F   		db ?         ;      0Fh    (1- 0-)
;    
     cFlg_66   		db ?         ;      66h    (1- 0-)
     cFlg_67   		db ?         ;      67h    (1- 0-)
     cFlg_F0   		db ?         ;      F0h    (1- 0-)
     cFlg_Seg  		db ?         ;        (0-)
     cFlg_Rep  		db ?         ;      (0-)
     cDflag    		db ?         ;     
     cWflag    		db ?         ;     

     cSflag    		db ?         ;      
     cFloat    		db ?         ;      (00xxxyyyb)
     cType     		db ?         ;     
     cFIn      		dd ?         ;         
     cFOut     		dd ?         ;
       ;00001-. Reg
       ;00002-. Mod/RM
       ;00004-EAX
       ;00008-EDX
       ;00016-ESI
       ;00032-EDI
       ;00064-ZF
       ;00128-SF
       ;00256-DF
       ;00512-CF
       ;01024-IF
       ;02048-Stack
       ;04096-Other flags (AF)
       ;08192-CR's
       ;16384-DR's
       ;32768-TR's
       ;65536-MSR
       ;131072-S{R}eg
       ;262144-CS:EIP 
       ;524288-PF 
       ;1048576-OF 
       ;2097152-(EBX,EBP)
       ;4194304-FPU
       ;8388608-Mem --- ?
       ;16777216-ECX
       ;33554432-PORTS
     cSReg     		db ?         ;	 SR (00xxx000b)
ends
ComandInfoLen  equ cSReg-cOpCod+1
_cell				struct
		_OpComInf	ComandInfo	?
		_Flag			db	?
							; 0 - normal comand
							; 1 - jmp
							; 2 - call
							; 3 - jcc
							; 4 - bad 
		_NextrStr		dd	? 
		_PreStr			dd	?
		_AddrComand		dd	?
		_AddrTrans		dd	?
		_Len			dd	? 
		_Label			dd	?          
		_NStr			dd	? 
		_NoMove			db	?
					ends 
SizeCell			equ size _cell
_MainStrVPE			struct
		MSize		dd	?
		ListHead	dd	? 
		ListEnd 	dd	?
		CNum		dd	?
					ends
_SizeMSVPE			=	size	_MainStrVPE 
;push	root                               

UnknowError			equ	-1
FlawMemory			equ	 1   
CalcAddr			equ	 2
;push	addr end free memory			
;push	size code
;push	addr code
;push	free mem
;call	VPE_krn
;add	esp, 4*3
;if (eax == 0) 		--> all ok
;elseif	(eax == 1) 	--> flaw of memory
;				   	--> edi - last structure  
;elseif (eax == -1) --> Unknow Error
;					--> Error DASM 
;elseif	(eax ==  2) --> Error calculate adress

VPE_krn:
		pusha
		mov		edi, [esp+32+4]
		mov		esi, [esp+32+4+4]
		mov		ecx, [esp+32+4+4+4]
		mov		ebx, [esp+32+4+4+4+4]
		xor		eax, eax
_MainCycle: 
		nop     
		call	DASM   
		mov		[edi]._PreStr, eax
		jc		_ErrorUnknow
		call	GetLen
		mov		4 ptr [edi]._AddrComand, esi 
		add		esi, eax
		mov		4 ptr [edi]._Len, eax
		call	Ans_Loop
		sub		ecx, eax
		jz		_Ok
		js		_Ok
		mov		eax, edi
		add		eax, SizeCell
		cmp		eax, ebx
		jg		_ErrorMem
		mov		4 ptr [edi]._NextrStr, eax
		xchg	eax, edi       
		inc		4 ptr [ebp].CNum
		jmp		_MainCycle 
		
_Ok:
		xor		eax, eax              
		mov		4 ptr [ebp].ListEnd, edi
		mov		4 ptr [edi]._NextrStr, eax
		push	4 ptr [esp+32+4]
		call	PreProcc
		pop		ecx   
		inc		eax
		jz		_CalcAddr
		xor		eax, eax          
		jmp		Exit
Ans_Loop:
		pusha 
		mov 	eax, 4 ptr [edi].cOpCod
    	cmp     al, 0E8h
    	je      _ProcCall32
        cmp     al, 0E9h
        je      _ProcJmp32
        cmp     al, 0EBh
        je      _ProcJmp8b1 
		push   	eax 
        cmp     al, 00Fh
        jne     _skip         
        and     ah, 0F0h
        cmp     ah, 80h
        je      _ProcJmp16h
_skip:                
        pop     eax
        and     al, 0F0h
        cmp     al, 70h
        je      _ProcJmp8b2	        	
_Next:	
		popa
		ret 

_ProcJmp8b2:			
		mov     1 ptr [edi]._Flag, 03h
_ProcJmp8b:
        mov     edx, [edi]._AddrComand
        xor		eax, eax
        mov     al, byte ptr [edx+1]
        cmp		eax, 07Fh
        jg		__91
__92:
        lea     ebx, [edx+2+eax]        					
		jmp		_skip1
__91:
		add		eax, 0FFFFFF00h
		jmp		__92
_ProcJmp32:
		mov		1 ptr [edi]._Flag, 1
		jmp		_ProcAddr32 

_ProcJmp16h:
		mov		1 ptr [edi]._Flag, 3
        mov     edx, [edi]._AddrComand
        mov     eax, [edx+2]
        lea     ebx, [edx+6+eax]
		jmp		_skip@		  
 		
_ProcAddr32:
        mov     edx, [edi]._AddrComand					
		mov		eax, 4 ptr [edx+1]
		lea		ebx, [edx+5+eax]
		jmp		_skip1			          
_ProcJmp8b1:
		mov		1 ptr [edi]._Flag, 1
		jmp		_ProcJmp8b		
_ProcCall32:
		mov		1 ptr [edi]._Flag, 2
		jmp		_ProcAddr32                     				  
_skip@:
		pop		eax		
_skip1:
		xchg	ebx, [edi]._AddrTrans				
_ret:   jmp		_Next

Exit:
		mov		[esp].popa_eax, eax
_OkAll:
		popa
		ret
		
_ErrorUnknow:
		xor		eax, eax 
		dec		eax
		jmp		short Exit	
_ErrorMem:
		xor		eax, eax
		inc		eax
		mov		[esp].popa_edi, edi
		jmp		short Exit       
_CalcAddr:
		xor		eax, eax
		mov		al, 2h
		jmp		short Exit
		
PreProcc:
		pusha
		mov		edi, [esp+32+4]       
		mov		edx, edi
Main_Loop:
		movzx	eax, 1 ptr [edi]._Flag
		or		eax, eax
		jz		_Skip20
		sub		al, 4
		jz		_Skip20 
		call	_Find
		jc		_@@111
	    cmp		[edi].cDLen, 4
        jz		__@@4
		mov		ax, 2 ptr [edi].cOpCod  
		cmp		al, 0EBh
		je		__I1
		cmp		al, 0E8h
		je		__@@9   
		mov		[edi].cDLen, 4 
		mov		[edi].cLen, 2
		mov		[edi]._Len, 6
		add		al, 10h
		mov		ah, 0Fh
		xchg	al, ah
__@@9:
		mov		2 ptr [edi].cOpCod, ax
        jmp		__@@4
__I1:
		mov		[edi].cDLen, 4
		mov		[edi].cLen, 1
		mov		[edi]._Len, 5
		mov		al, 0E9h
		mov		2 ptr [edi].cOpCod, ax
__@@4:
		mov		[edi]._Label, ebx
		mov		[ebx]._Label, 1
_Skip20:
		mov		edi, [edi]._NextrStr
		or		edi, edi
		jz		_@@1
		jmp		Main_Loop
_Find:
		push	edx
		mov		eax, [edi]._AddrTrans
_@1:
		cmp		eax, [edx]._AddrComand
		jz		_@2
		mov		edx, [edx]._NextrStr
		or		edx, edx
		jz		_@@2
		jmp		_@1
_@@111:
		mov		[esp].popa_eax, -1      
_@@1:
		popa
		ret             

		
_@2:
		mov		ebx, edx
		pop		edx
		clc
		ret
	
_@@2:
		pop		edx
		stc
		ret 
                    
CalcVAddr:
		xor		eax, eax    
__@@3:
		mov		[edi]._NStr, eax
		mov		edi, [edi]._NextrStr
		or		edi, edi
		jnz		__@@dd    
		ret
__@@dd:
		add		eax, [edi]._Len
		jmp		__@@3   
SizeVPE_krn	=	$ - VPE_krn 		
nop                            

VPE_JmpFix:
		pusha  
		mov		edi, [esp+32+4]   
		push	edi
		call	CalcVAddr
		pop		edi
		mov		edi, [edi]._NextrStr
__@@5:
		mov		edx, [edi]._Label
		or		edx, edx
		jz		__@@6 
		dec		edx
		jz		__@@6
		inc		edx
        mov		eax, [edx]._NStr             
        mov		esi, [edi]._NStr
        add		esi, [edx]._Len
        sub		eax, esi         
		mov		4 ptr [edi].cData, eax
__@@6:
		mov		edi, [edi]._NextrStr
		or		edi, edi
		jz		__@@10                    
		jmp		__@@5
__@@10:
		popa
		ret  

DASM	        proc 	near
                pusha
                xor     eax, eax
                mov     ecx, SizeCell
                push    edi
                repe stosb
                pop     edi

loc_401011:                             ; CODE XREF: start+1Fj
                                        ; start+29j ...
                lodsd
                mov     [edi], eax
                dec     esi
                dec     esi
                dec     esi
                cmp     al, 66h
                jnz     short loc_401021
                mov     byte ptr [edi+1Ch], 1
                jmp     short loc_401011
; ---------------------------------------------------------------------------

loc_401021:                             ; CODE XREF: start+19j
                cmp     al, 67h
                jnz     short loc_40102B
                mov     byte ptr [edi+1Dh], 1
                jmp     short loc_401011
; ---------------------------------------------------------------------------

loc_40102B:                             ; CODE XREF: start+23j
                mov     ebx, eax
                and     ebx, 0E7h
                cmp     ebx, 26h
                jz      short loc_401042
                mov     ebx, eax
                and     bl, 0FEh
                cmp     bl, 64h
                jnz     short loc_401047

loc_401042:                             ; CODE XREF: start+36j
                mov     [edi+1Fh], al
                jmp     short loc_401011
; ---------------------------------------------------------------------------

loc_401047:                             ; CODE XREF: start+40j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 0F2h
                jnz     short loc_40105C
                mov     [edi+20h], al
                jmp     short loc_401011
; ---------------------------------------------------------------------------

loc_40105C:                             ; CODE XREF: start+55j
                cmp     al, 0F0h
                jnz     short loc_401066
                mov     byte ptr [edi+1Eh], 1
                jmp     short loc_401011
; ---------------------------------------------------------------------------

loc_401066:                             ; CODE XREF: start+5Ej
                cmp     al, 0Fh
                jnz     short loc_401076
                mov     byte ptr [edi+1Bh], 1
                shr     eax, 8
                jmp     loc_401DAA
; ---------------------------------------------------------------------------

loc_401076:                             ; CODE XREF: start+68j
                inc     esi
                mov     byte ptr [edi+10h], 2
                mov     ebx, eax
                and     ebx, 0FCh
                cmp     ebx, 88h
                jnz     short loc_4010BC
                mov     byte ptr [edi+25h], 41h
                push    eax
                and     al, 2
                shr     al, 1
                mov     [edi+21h], al
                mov     dword ptr [edi+26h], 1
                mov     dword ptr [edi+2Ah], 2
                cmp     al, 0
                jz      short loc_4010B1
                xor     dword ptr [edi+26h], 3
                xor     dword ptr [edi+2Ah], 3

loc_4010B1:                             ; CODE XREF: start+A7j
                pop     eax
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_4010BC:                             ; CODE XREF: start+89j
                mov     ebx, eax
                and     ebx, 0FDh
                cmp     ebx, 8Ch
                jnz     short loc_401125
                mov     bh, ah
                and     bh, 38h
                jz      short loc_4010F2
                cmp     bh, 30h
                jz      loc_4024C7
                cmp     bh, 38h
                jz      loc_4024C7
                test    al, 2
                jz      short loc_4010F2
                cmp     bh, 8
                jz      loc_4024C7

loc_4010F2:                             ; CODE XREF: start+D1j
                                        ; start+E7j
                mov     [edi+2Eh], bh
                mov     byte ptr [edi+25h], 42h
                and     al, 2
                shr     al, 1
                mov     [edi+21h], al
                mov     dword ptr [edi+26h], 20000h
                mov     dword ptr [edi+2Ah], 2
                cmp     al, 0
                jz      short loc_401120
                xor     dword ptr [edi+26h], 20001h
                xor     dword ptr [edi+2Ah], 20001h

loc_401120:                             ; CODE XREF: start+110j
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401125:                             ; CODE XREF: start+CAj
                mov     ebx, eax
                and     ebx, 38FFh
                cmp     ebx, 30FFh
                jnz     short loc_40114C
                mov     byte ptr [edi+25h], 43h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 800h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_40114C:                             ; CODE XREF: start+133j
                mov     ebx, eax
                and     ebx, 38FFh
                cmp     ebx, 8Fh
                jnz     short loc_401173
                mov     dword ptr [edi+26h], 800h
                mov     dword ptr [edi+2Ah], 2
                mov     byte ptr [edi+25h], 44h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401173:                             ; CODE XREF: start+15Aj
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 0FFh
                jnz     short loc_4011B5
                mov     bh, ah
                and     bh, 38h
                cmp     bh, 10h
                jz      short loc_401192
                cmp     bh, 20h
                jnz     short loc_4011B5

loc_401192:                             ; CODE XREF: start+18Bj
                mov     byte ptr [edi+25h], 45h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 40000h
                test    ah, 10h
                jnz     short loc_4011B0
                or      dword ptr [edi+2Ah], 800h

loc_4011B0:                             ; CODE XREF: start+1A7j
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_4011B5:                             ; CODE XREF: start+181j
                                        ; start+190j
                mov     ebx, eax
                and     ebx, 0FCh
                cmp     ebx, 84h
                jnz     short loc_4011F7
                mov     byte ptr [edi+25h], 46h
                test    ax, 2
                jz      short loc_4011DF
                mov     dword ptr [edi+26h], 3
                mov     dword ptr [edi+2Ah], 3
                jmp     short loc_4011ED
; ---------------------------------------------------------------------------

loc_4011DF:                             ; CODE XREF: start+1CDj
                mov     dword ptr [edi+26h], 3
                mov     dword ptr [edi+2Ah], 1812C0h

loc_4011ED:                             ; CODE XREF: start+1DDj
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_4011F7:                             ; CODE XREF: start+1C3j
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 8Dh
                jnz     short loc_40122D
                mov     ebx, eax
                and     bh, 0C0h
                cmp     bh, 0C0h
                jz      short loc_401228
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 1
                mov     byte ptr [edi+25h], 47h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401228:                             ; CODE XREF: start+20Fj
                jmp     loc_4024C7
; ---------------------------------------------------------------------------

loc_40122D:                             ; CODE XREF: start+205j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 0C4h
                jnz     short loc_401272
                mov     bl, ah
                and     bl, 0C0h
                cmp     bl, 0C0h
                jz      short loc_40126D
                mov     bh, al
                and     bh, 3
                cmp     bh, 1
                jnz     short loc_401253
                mov     bh, 18h

loc_401253:                             ; CODE XREF: start+24Fj
                mov     [edi+2Eh], bh
                mov     byte ptr [edi+25h], 48h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 20001h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_40126D:                             ; CODE XREF: start+245j
                jmp     loc_4024C7
; ---------------------------------------------------------------------------

loc_401272:                             ; CODE XREF: start+23Bj
                mov     ebx, eax
                and     ebx, 0C4h
                or      ebx, ebx
                jnz     short loc_4012D8
                mov     byte ptr [edi+25h], 49h
                or      bx, ax
                and     bl, 38h
                mov     dword ptr [edi+26h], 3
                mov     dword ptr [edi+2Ah], 1812C0h
                test    ebx, 20h
                jnz     short loc_4012AD
                test    ebx, 10h
                jz      short loc_4012AD
                or      dword ptr [edi+26h], 200h

loc_4012AD:                             ; CODE XREF: start+29Cj
                                        ; start+2A4j
                not     bx
                test    bx, 38h
                jz      short loc_4012C5
                test    al, 2
                jz      short loc_4012C1
                or      dword ptr [edi+2Ah], 1
                jmp     short loc_4012C5
; ---------------------------------------------------------------------------

loc_4012C1:                             ; CODE XREF: start+2B9j
                or      dword ptr [edi+2Ah], 2

loc_4012C5:                             ; CODE XREF: start+2B5j
                                        ; start+2BFj
                push    eax
                and     al, 2
                shr     al, 1
                mov     [edi+21h], al
                pop     eax
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_4012D8:                             ; CODE XREF: start+27Cj
                mov     ebx, eax
                and     ebx, 30FEh
                cmp     ebx, 0FEh
                jnz     short loc_401304
                mov     byte ptr [edi+25h], 4Ah
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 1810C2h
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401304:                             ; CODE XREF: start+2E6j
                mov     ebx, eax
                and     ebx, 38FEh
                cmp     ebx, 18F6h
                jnz     short loc_401330
                mov     byte ptr [edi+25h], 4Bh
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 812C2h
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401330:                             ; CODE XREF: start+312j
                mov     ebx, eax
                and     ebx, 38FEh
                cmp     ebx, 10F6h
                jnz     short loc_40135C
                mov     byte ptr [edi+25h], 4Ch
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 2
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_40135C:                             ; CODE XREF: start+33Ej
                mov     ebx, eax
                and     ebx, 20FEh
                cmp     ebx, 20F6h
                jnz     short loc_40139E
                mov     byte ptr [edi+25h], 4Dh
                mov     dword ptr [edi+26h], 6
                test    ah, 20h
                jz      short loc_401389
                or      dword ptr [edi+26h], 8
                mov     dword ptr [edi+2Ah], 81288h
                jmp     short loc_401390
; ---------------------------------------------------------------------------

loc_401389:                             ; CODE XREF: start+37Aj
                mov     dword ptr [edi+2Ah], 100208h

loc_401390:                             ; CODE XREF: start+387j
                or      dword ptr [edi+2Ah], 6
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_40139E:                             ; CODE XREF: start+36Aj
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 62h
                jnz     short loc_4013D3
                mov     bl, ah
                and     bl, 0C0h
                cmp     bl, 0C0h
                jz      short loc_4013CE
                mov     byte ptr [edi+25h], 4Eh
                mov     dword ptr [edi+26h], 3
                mov     dword ptr [edi+2Ah], 0
                mov     al, 1
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_4013CE:                             ; CODE XREF: start+3B3j
                jmp     loc_4024C7
; ---------------------------------------------------------------------------

loc_4013D3:                             ; CODE XREF: start+3A9j
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 63h
                jnz     short loc_4013F9
                mov     byte ptr [edi+25h], 4Fh
                mov     dword ptr [edi+26h], 3
                mov     dword ptr [edi+2Ah], 42h
                mov     al, 1
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_4013F9:                             ; CODE XREF: start+3DEj
                mov     ebx, eax
                and     ebx, 0F8h
                cmp     ebx, 0D8h
                jnz     short loc_40142F
                mov     [edi+24h], al
                and     byte ptr [edi+24h], 7
                mov     bl, ah
                and     bl, 38h
                or      [edi+24h], bl
                mov     byte ptr [edi+25h], 50h
                mov     dword ptr [edi+26h], 400002h
                mov     dword ptr [edi+2Ah], 400002h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_40142F:                             ; CODE XREF: start+407j
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 0FFh
                jnz     short loc_40147D
                mov     bl, ah
                and     bl, 38h
                cmp     bl, 18h
                jz      short loc_401450
                cmp     bl, 28h
                jnz     short loc_40147D
                jmp     short loc_401457
; ---------------------------------------------------------------------------

loc_401450:                             ; CODE XREF: start+447j
                mov     dword ptr [edi+2Ah], 800h

loc_401457:                             ; CODE XREF: start+44Ej
                mov     bh, ah
                and     bh, 0C0h
                cmp     bh, 0C0h
                jz      short loc_401478
                mov     byte ptr [edi+25h], 51h
                mov     dword ptr [edi+26h], 2
                or      dword ptr [edi+2Ah], 40000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401478:                             ; CODE XREF: start+45Fj
                jmp     loc_4024C7
; ---------------------------------------------------------------------------

loc_40147D:                             ; CODE XREF: start+43Dj
                                        ; start+44Cj
                mov     ebx, eax
                and     ebx, 38FEh
                cmp     ebx, 0C6h
                jnz     short loc_4014A9
                mov     byte ptr [edi+25h], 61h
                mov     dword ptr [edi+26h], 0
                mov     dword ptr [edi+2Ah], 2
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024DA
; ---------------------------------------------------------------------------

loc_4014A9:                             ; CODE XREF: start+48Bj
                mov     ebx, eax
                and     ebx, 0FCh
                cmp     ebx, 80h
                jnz     short loc_4014F7
                mov     byte ptr [edi+25h], 62h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 1812C0h
                mov     bx, ax
                xor     bl, 38h
                and     bl, 38h
                jz      short loc_4014DA
                or      dword ptr [edi+2Ah], 2

loc_4014DA:                             ; CODE XREF: start+4D4j
                push    eax
                and     al, 1
                mov     [edi+22h], al
                pop     eax
                shr     al, 1
                and     al, 1
                mov     [edi+23h], al
                test    byte ptr [edi+22h], 3
                jnz     short loc_4014F0
                or      al, 1

loc_4014F0:                             ; CODE XREF: start+4ECj
                xor     al, 1
                jmp     loc_4024DA
; ---------------------------------------------------------------------------

loc_4014F7:                             ; CODE XREF: start+4B7j
                mov     ebx, eax
                and     ebx, 38FEh
                cmp     ebx, 0F6h
                jnz     short loc_401523
                mov     byte ptr [edi+25h], 63h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 1812C0h
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024DA
; ---------------------------------------------------------------------------

loc_401523:                             ; CODE XREF: start+505j
                mov     ebx, eax
                test    al, 1
                jnz     short loc_40152F
                mov     byte ptr [edi+22h], 0
                jmp     short loc_401533
; ---------------------------------------------------------------------------

loc_40152F:                             ; CODE XREF: start+527j
                mov     byte ptr [edi+22h], 1

loc_401533:                             ; CODE XREF: start+52Dj
                and     ebx, 0ECh
                cmp     ebx, 0C0h
                jnz     short loc_4015A0
                mov     ebx, eax
                and     bl, 12h
                cmp     bl, 2
                jz      short loc_4015A0
                mov     byte ptr [edi+25h], 64h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 1812C2h
                mov     bx, ax
                xor     bx, 0B6h
                test    bx, 12h
                jnz     short loc_401573
                or      dword ptr [edi+26h], 1000000h

loc_401573:                             ; CODE XREF: start+56Aj
                test    ah, 20h
                jnz     short loc_401584
                test    ah, 10h
                jz      short loc_401584
                or      dword ptr [edi+26h], 200h

loc_401584:                             ; CODE XREF: start+576j
                                        ; start+57Bj
                call    sub_4024E7
                test    al, 10h
                jnz     short loc_401597
                lodsb
                mov     [edi+0Ah], al
                mov     byte ptr [edi+12h], 1
                jmp     short loc_40159B
; ---------------------------------------------------------------------------

loc_401597:                             ; CODE XREF: start+58Bj
                mov     byte ptr [edi+12h], 0

loc_40159B:                             ; CODE XREF: start+595j
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4015A0:                             ; CODE XREF: start+53Fj
                                        ; start+549j
                mov     ebx, eax
                and     ebx, 0FDh
                cmp     ebx, 69h
                jnz     short loc_4015CD
                mov     byte ptr [edi+25h], 65h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 100201h
                and     al, 2
                shr     al, 1
                mov     [edi+23h], al
                xor     al, 1
                jmp     loc_4024DA
; ---------------------------------------------------------------------------

loc_4015CD:                             ; CODE XREF: start+5ABj
                mov     byte ptr [edi+10h], 1
                dec     esi
                mov     ebx, eax
                and     ebx, 0F0h
                cmp     ebx, 50h
                jnz     short loc_401614
                mov     bx, ax
                and     bl, 0Fh
                shl     ebx, 3
                mov     [edi+16h], bl
                mov     dword ptr [edi+26h], 1
                mov     dword ptr [edi+2Ah], 800h
                test    al, 8
                jz      short loc_40160B
                xor     dword ptr [edi+26h], 801h
                xor     dword ptr [edi+2Ah], 801h

loc_40160B:                             ; CODE XREF: start+5FBj
                mov     byte ptr [edi+25h], 1
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401614:                             ; CODE XREF: start+5DDj
                mov     ebx, eax
                and     ebx, 0E6h
                cmp     ebx, 6
                jnz     short loc_401656
                cmp     al, 0Fh
                jz      short loc_401656
                mov     byte ptr [edi+25h], 2
                mov     bl, al
                and     bl, 18h
                mov     [edi+2Eh], bl
                mov     dword ptr [edi+26h], 20000h
                mov     dword ptr [edi+2Ah], 800h
                test    al, 1
                jz      short loc_401651
                xor     dword ptr [edi+26h], 20800h
                xor     dword ptr [edi+2Ah], 20800h

loc_401651:                             ; CODE XREF: start+641j
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401656:                             ; CODE XREF: start+61Fj
                                        ; start+623j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 60h
                jnz     short loc_40168C
                mov     byte ptr [edi+25h], 3
                mov     dword ptr [edi+26h], 800h
                mov     dword ptr [edi+2Ah], 120003Ch
                test    al, 1
                jnz     short loc_401687
                xor     dword ptr [edi+26h], 120083Ch
                xor     dword ptr [edi+2Ah], 120083Ch

loc_401687:                             ; CODE XREF: start+677j
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40168C:                             ; CODE XREF: start+661j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 9Ch
                jnz     short loc_4016C5
                mov     byte ptr [edi+25h], 4
                mov     dword ptr [edi+26h], 800h
                mov     dword ptr [edi+2Ah], 1817C0h
                test    al, 1
                jnz     short loc_4016C0
                xor     dword ptr [edi+26h], 181FC0h
                xor     dword ptr [edi+2Ah], 181FC0h

loc_4016C0:                             ; CODE XREF: start+6B0j
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4016C5:                             ; CODE XREF: start+69Aj
                mov     ebx, eax
                and     ebx, 0F8h
                cmp     ebx, 90h
                jnz     short loc_4016FF
                cmp     al, 90h
                jz      loc_401899
                mov     byte ptr [edi+25h], 5
                mov     [edi+16h], al
                and     byte ptr [edi+16h], 7
                shl     byte ptr [edi+16h], 3
                mov     dword ptr [edi+26h], 5
                mov     dword ptr [edi+2Ah], 5
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4016FF:                             ; CODE XREF: start+6D3j
                mov     ebx, eax
                and     ebx, 0F8h
                cmp     ebx, 0F8h
                jnz     short loc_40174B
                mov     ebx, eax
                and     ebx, 7
                cmp     ebx, 6
                jge     short loc_40174B
                mov     byte ptr [edi+25h], 6
                mov     dword ptr [edi+26h], 0
                mov     bl, al
                and     ebx, 6
                jz      short loc_40173E
                test    bl, 2
                jnz     short loc_401737
                mov     ebx, 400h
                jmp     short loc_401743
; ---------------------------------------------------------------------------

loc_401737:                             ; CODE XREF: start+72Ej
                mov     ebx, 100h
                jmp     short loc_401743
; ---------------------------------------------------------------------------

loc_40173E:                             ; CODE XREF: start+729j
                mov     ebx, 200h

loc_401743:                             ; CODE XREF: start+735j
                                        ; start+73Cj
                mov     [edi+2Ah], ebx
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40174B:                             ; CODE XREF: start+70Dj
                                        ; start+717j
                mov     ebx, eax
                and     ebx, 0F0h
                cmp     ebx, 40h
                jnz     short loc_40176F
                mov     byte ptr [edi+25h], 7
                mov     dword ptr [edi+26h], 1
                mov     dword ptr [edi+2Ah], 1810C1h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40176F:                             ; CODE XREF: start+756j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 98h
                jnz     short loc_4017AD
                mov     byte ptr [edi+25h], 8
                test    al, 1
                jz      short loc_40179A
                mov     dword ptr [edi+26h], 4
                mov     dword ptr [edi+2Ah], 8
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40179A:                             ; CODE XREF: start+785j
                mov     dword ptr [edi+26h], 4
                mov     dword ptr [edi+2Ah], 4
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4017AD:                             ; CODE XREF: start+77Dj
                mov     ebx, eax
                and     ebx, 0F0h
                cmp     ebx, 0A0h
                jnz     loc_40185B
                mov     ebx, eax
                and     ebx, 0FCh
                cmp     ebx, 0A0h
                jz      loc_4019FB
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 0A8h
                jz      loc_401AC8
                mov     byte ptr [edi+25h], 9
                mov     dword ptr [edi+26h], 30h
                mov     bx, ax
                and     bl, 0Eh
                cmp     bl, 0Ch
                jnz     short loc_40180A
                xor     dword ptr [edi+26h], 20h
                mov     dword ptr [edi+2Ah], 14h

loc_40180A:                             ; CODE XREF: start+7FDj
                not     bl
                test    bl, 0Ah
                jnz     short loc_401817
                xor     dword ptr [edi+2Ah], 10h
                not     bl

loc_401817:                             ; CODE XREF: start+80Fj
                cmp     bl, 0Ah
                jnz     short loc_401831
                mov     ebx, [edi+26h]
                or      ebx, 20h
                mov     dword ptr [edi+26h], 4
                mov     [edi+2Ah], ebx
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401831:                             ; CODE XREF: start+81Aj
                cmp     bl, 4
                jnz     short loc_40183F
                mov     dword ptr [edi+2Ah], 30h
                jmp     short loc_401856
; ---------------------------------------------------------------------------

loc_40183F:                             ; CODE XREF: start+834j
                cmp     bl, 0Eh
                jnz     short loc_401854
                or      dword ptr [edi+26h], 4

loc_401848:                             ; CODE XREF: start+854j
                mov     dword ptr [edi+2Ah], 1812C0h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401854:                             ; CODE XREF: start+842j
                jmp     short loc_401848
; ---------------------------------------------------------------------------

loc_401856:                             ; CODE XREF: start+83Dj
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40185B:                             ; CODE XREF: start+7BBj
                cmp     al, 0D7h
                jnz     short loc_40187E
                mov     byte ptr [edi+25h], 0Ah
                mov     byte ptr [edi+16h], 18h
                mov     byte ptr [edi+2Eh], 0
                mov     dword ptr [edi+26h], 20005h
                mov     dword ptr [edi+2Ah], 4
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40187E:                             ; CODE XREF: start+85Dj
                cmp     al, 0C3h
                jnz     short loc_401899
                mov     byte ptr [edi+25h], 0Ch
                mov     dword ptr [edi+26h], 800h
                mov     dword ptr [edi+2Ah], 40000h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401899:                             ; CODE XREF: start+6D7j
                                        ; start+880j
                cmp     al, 90h
                jnz     short loc_4018B4
                mov     byte ptr [edi+25h], 0Dh
                mov     dword ptr [edi+26h], 0
                mov     dword ptr [edi+2Ah], 0
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4018B4:                             ; CODE XREF: start+89Bj
                cmp     al, 0CCh
                jnz     short loc_4018CF
                mov     byte ptr [edi+25h], 0Eh
                mov     dword ptr [edi+26h], 0FFFFFFFFh
                mov     dword ptr [edi+2Ah], 0FFFFFFFFh
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4018CF:                             ; CODE XREF: start+8B6j
                mov     bl, al
                and     bl, 0FCh
                cmp     bl, 6Ch
                jnz     short loc_40190C
                and     al, 1
                mov     [edi+22h], al
                mov     byte ptr [edi+25h], 0Fh
                test    al, 2
                jnz     short loc_4018F9
                mov     dword ptr [edi+26h], 2000018h
                mov     dword ptr [edi+2Ah], 10h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4018F9:                             ; CODE XREF: start+8E4j
                mov     dword ptr [edi+26h], 28h
                mov     dword ptr [edi+2Ah], 2000020h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40190C:                             ; CODE XREF: start+8D7j
                cmp     al, 0F5h
                jnz     short loc_401927
                mov     byte ptr [edi+25h], 10h
                mov     dword ptr [edi+2Ah], 200h
                mov     dword ptr [edi+26h], 200h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401927:                             ; CODE XREF: start+90Ej
                mov     bl, al
                or      bl, 1
                cmp     bl, 9Fh
                jnz     short loc_40195A
                mov     byte ptr [edi+25h], 11h
                mov     dword ptr [edi+26h], 812C0h
                mov     dword ptr [edi+2Ah], 4
                test    al, 1
                jz      short loc_401955
                mov     dword ptr [edi+2Ah], 812C0h
                mov     dword ptr [edi+26h], 4

loc_401955:                             ; CODE XREF: start+945j
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40195A:                             ; CODE XREF: start+92Fj
                mov     bl, al
                or      bl, 18h
                cmp     bl, 3Fh
                jnz     short loc_40197B
                mov     byte ptr [edi+25h], 12h
                mov     dword ptr [edi+26h], 4
                mov     dword ptr [edi+2Ah], 1204h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40197B:                             ; CODE XREF: start+962j
                cmp     al, 0F4h
                jnz     short loc_401996
                mov     byte ptr [edi+25h], 14h
                mov     dword ptr [edi+26h], 0
                mov     dword ptr [edi+2Ah], 0
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401996:                             ; CODE XREF: start+97Dj
                cmp     al, 9Bh
                jnz     short loc_4019B1
                mov     byte ptr [edi+25h], 15h
                mov     dword ptr [edi+26h], 400000h
                mov     dword ptr [edi+2Ah], 400000h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4019B1:                             ; CODE XREF: start+998j
                cmp     al, 0D6h
                jnz     short loc_4019CC
                mov     byte ptr [edi+25h], 16h
                mov     dword ptr [edi+26h], 200h
                mov     dword ptr [edi+2Ah], 4
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4019CC:                             ; CODE XREF: start+9B3j
                mov     ebx, eax
                and     ebx, 0F0h
                cmp     ebx, 0B0h
                jnz     short loc_4019FB
                mov     byte ptr [edi+25h], 21h
                mov     dword ptr [edi+26h], 0
                mov     dword ptr [edi+2Ah], 1
                shr     al, 3
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_4019FB:                             ; CODE XREF: start+7CFj
                                        ; start+9DAj
                mov     ebx, eax
                and     ebx, 0FCh
                cmp     ebx, 0A0h
                jnz     short loc_401A48
                mov     byte ptr [edi+25h], 22h
                push    eax
                shl     al, 1
                and     al, 1
                mov     [edi+21h], al
                mov     dword ptr [edi+26h], 4
                mov     dword ptr [edi+2Ah], 800000h
                jz      short loc_401A35
                xor     dword ptr [edi+26h], 800004h
                xor     dword ptr [edi+2Ah], 800004h

loc_401A35:                             ; CODE XREF: start+A25j
                pop     eax
                and     al, 1
                mov     [edi+22h], al
                lodsd
                mov     [edi+0Ah], eax
                mov     byte ptr [edi+12h], 4
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401A48:                             ; CODE XREF: start+A09j
                mov     ebx, eax
                and     ebx, 0FDh
                cmp     ebx, 68h
                jnz     short loc_401A75
                mov     byte ptr [edi+25h], 23h
                mov     dword ptr [edi+26h], 0
                mov     dword ptr [edi+2Ah], 800h
                shr     al, 1
                and     al, 1
                mov     [edi+23h], al
                xor     al, 1
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_401A75:                             ; CODE XREF: start+A53j
                mov     ebx, eax
                and     ebx, 0C6h
                cmp     ebx, 4
                jnz     short loc_401AC8
                mov     byte ptr [edi+25h], 24h
                mov     ebx, eax
                and     bl, 38h
                mov     dword ptr [edi+26h], 4
                mov     dword ptr [edi+2Ah], 1812C0h
                test    ebx, 20h
                jnz     short loc_401AB0
                test    ebx, 10h
                jz      short loc_401AB0
                or      dword ptr [edi+26h], 200h

loc_401AB0:                             ; CODE XREF: start+A9Fj
                                        ; start+AA7j
                not     bx
                test    bx, 38h
                jz      short loc_401ABE
                or      dword ptr [edi+2Ah], 4

loc_401ABE:                             ; CODE XREF: start+AB8j
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_401AC8:                             ; CODE XREF: start+7E3j
                                        ; start+A80j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 0A8h
                jnz     short loc_401AF4
                mov     byte ptr [edi+25h], 25h
                mov     dword ptr [edi+26h], 4
                mov     dword ptr [edi+2Ah], 800C0h
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_401AF4:                             ; CODE XREF: start+AD6j
                mov     ebx, eax
                and     ebx, 0FCh
                cmp     ebx, 0E8h
                jnz     short loc_401B41
                mov     byte ptr [edi+25h], 26h
                mov     dword ptr [edi+26h], 0
                mov     dword ptr [edi+2Ah], 40000h
                and     al, 3
                cmp     al, 3
                jnz     short loc_401B23
                sub     al, al
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_401B23:                             ; CODE XREF: start+B1Aj
                cmp     al, 2
                jnz     short loc_401B3A
                lodsd
                mov     [edi+0Ah], eax
                lodsw
                mov     [edi+0Eh], ax
                mov     byte ptr [edi+12h], 6
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401B3A:                             ; CODE XREF: start+B25j
                mov     al, 1
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_401B41:                             ; CODE XREF: start+B02j
                mov     ebx, eax
                and     ebx, 0F0h
                cmp     ebx, 70h
                jnz     short loc_401BC2
                mov     byte ptr [edi+25h], 28h
                mov     dword ptr [edi+2Ah], 40000h
                mov     dword ptr [edi+26h], 0
                and     al, 0Eh
                jnz     short loc_401B6D
                or      dword ptr [edi+26h], 100000h
                jmp     short loc_401BBB
; ---------------------------------------------------------------------------

loc_401B6D:                             ; CODE XREF: start+B62j
                cmp     al, 2
                jnz     short loc_401B7A
                or      dword ptr [edi+26h], 200h
                jmp     short loc_401BBB
; ---------------------------------------------------------------------------

loc_401B7A:                             ; CODE XREF: start+B6Fj
                cmp     al, 4
                jnz     short loc_401B87
                mov     dword ptr [edi+26h], 40h
                jmp     short loc_401BBB
; ---------------------------------------------------------------------------

loc_401B87:                             ; CODE XREF: start+B7Cj
                cmp     al, 6
                jnz     short loc_401B94
                mov     dword ptr [edi+26h], 240h
                jmp     short loc_401BBB
; ---------------------------------------------------------------------------

loc_401B94:                             ; CODE XREF: start+B89j
                cmp     al, 8
                jnz     short loc_401BA1
                mov     dword ptr [edi+26h], 80h
                jmp     short loc_401BBB
; ---------------------------------------------------------------------------

loc_401BA1:                             ; CODE XREF: start+B96j
                cmp     al, 0Ah
                jnz     short loc_401BAC
                mov     dword ptr [edi+26h], 80000h

loc_401BAC:                             ; CODE XREF: start+BA3j
                mov     dword ptr [edi+26h], 100080h
                test    al, 2
                jz      short loc_401BBB
                or      dword ptr [edi+26h], 40h

loc_401BBB:                             ; CODE XREF: start+B6Bj
                                        ; start+B78j ...
                sub     al, al
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_401BC2:                             ; CODE XREF: start+B4Cj
                mov     ebx, eax
                and     ebx, 0FCh
                cmp     ebx, 0E0h
                jnz     short loc_401C04
                mov     byte ptr [edi+25h], 29h
                mov     dword ptr [edi+26h], 1000000h
                test    al, 2
                jnz     short loc_401BE5
                or      dword ptr [edi+26h], 40h

loc_401BE5:                             ; CODE XREF: start+BDFj
                                        ; start+CADj
                mov     dword ptr [edi+2Ah], 1040000h
                test    al, 3
                jz      short loc_401BFD
                not     al
                test    al, 3
                jnz     short loc_401BFD
                xor     dword ptr [edi+2Ah], 1000000h

loc_401BFD:                             ; CODE XREF: start+BEEj
                                        ; start+BF4j
                sub     al, al
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_401C04:                             ; CODE XREF: start+BD0j
                mov     ebx, eax
                and     ebx, 0F4h
                cmp     ebx, 0E4h
                jnz     short loc_401C54
                mov     byte ptr [edi+25h], 2Bh
                mov     dword ptr [edi+26h], 2000000h
                mov     dword ptr [edi+2Ah], 4
                test    al, 2
                jz      short loc_401C38
                xor     dword ptr [edi+26h], 2000004h
                xor     dword ptr [edi+2Ah], 2000004h

loc_401C38:                             ; CODE XREF: start+C28j
                test    al, 8
                jz      short loc_401C4A
                or      dword ptr [edi+26h], 8
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401C4A:                             ; CODE XREF: start+C3Aj
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_401C54:                             ; CODE XREF: start+C12j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 0D4h
                jnz     short loc_401C7D
                mov     byte ptr [edi+25h], 2Ch
                mov     dword ptr [edi+26h], 4
                mov     dword ptr [edi+2Ah], 4
                mov     al, 0
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_401C7D:                             ; CODE XREF: start+C62j
                mov     ebx, eax
                and     ebx, 0F8h
                cmp     ebx, 0C8h
                jnz     loc_401D2C
                mov     byte ptr [edi+25h], 2Dh
                mov     dword ptr [edi+2Ah], 40000h
                mov     dword ptr [edi+26h], 0
                mov     ebx, eax
                and     bl, 7
                jz      short loc_401D09
                test    bl, 4
                jnz     loc_401BE5
                or      dword ptr [edi+26h], 800h
                cmp     bl, 7
                jz      short loc_401CC6
                or      dword ptr [edi+2Ah], 800h

loc_401CC6:                             ; CODE XREF: start+CBDj
                cmp     bl, 2
                jz      short loc_401CD9
                cmp     bl, 5
                jz      short loc_401CE8
                mov     byte ptr [edi+12h], 0
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401CD9:                             ; CODE XREF: start+CC9j
                lodsw
                mov     [edi+0Ah], ax
                mov     byte ptr [edi+12h], 2
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401CE8:                             ; CODE XREF: start+CCEj
                lodsb
                cmp     al, 20h
                jnz     short loc_401CFD
                mov     [edi+0Ah], al
                lodsd
                mov     [edi+0Bh], eax
                mov     byte ptr [edi+12h], 5
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401CFD:                             ; CODE XREF: start+CEBj
                mov     [edi+0Ah], al
                mov     byte ptr [edi+12h], 1
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401D09:                             ; CODE XREF: start+CA8j
                or      dword ptr [edi+2Ah], 800h
                xor     eax, eax
                lodsw
                push    eax
                xor     eax, eax
                lodsb
                shl     eax, 10h
                mov     ebx, eax
                pop     eax
                add     eax, ebx
                mov     [edi+0Ah], eax
                mov     byte ptr [edi+12h], 3
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401D2C:                             ; CODE XREF: start+C8Bj
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 0C2h
                jnz     short loc_401D5D
                mov     byte ptr [edi+25h], 2Eh
                mov     dword ptr [edi+26h], 800h
                mov     dword ptr [edi+2Ah], 40000h
                lodsw
                mov     [edi+0Ah], ax
                mov     byte ptr [edi+12h], 2
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401D5D:                             ; CODE XREF: start+D3Aj
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 9Ah
                jnz     short loc_401DA5
                mov     byte ptr [edi+25h], 2Fh
                mov     dword ptr [edi+26h], 0
                mov     dword ptr [edi+2Ah], 40800h
                test    byte ptr [edi+1Ch], 1
                jz      short loc_401D92
                lodsd
                mov     [edi+0Ah], eax
                mov     byte ptr [edi+12h], 4
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401D92:                             ; CODE XREF: start+D83j
                lodsd
                mov     [edi+0Ah], eax
                lodsw
                mov     [edi+0Eh], ax
                mov     byte ptr [edi+12h], 6
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401DA5:                             ; CODE XREF: start+D6Bj
                jmp     loc_4024C7
; ---------------------------------------------------------------------------

loc_401DAA:                             ; CODE XREF: start+71j
                mov     byte ptr [edi+10h], 3
                inc     esi
                inc     esi
                mov     ebx, eax
                and     ebx, 0F6h
                cmp     ebx, 0B6h
                jnz     short loc_401DDC
                and     al, 1
                mov     [edi+22h], al
                mov     byte ptr [edi+25h], 0A1h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 1
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401DDC:                             ; CODE XREF: start+DBEj
                mov     ebx, eax
                and     ebx, 0F8h
                cmp     ebx, 0B0h
                jnz     short loc_401E3B
                mov     ebx, eax
                and     ebx, 7
                cmp     ebx, 6
                jge     short loc_401E3B
                cmp     ebx, 2
                jz      short loc_401E00
                cmp     ebx, 4
                jl      short loc_401E3B

loc_401E00:                             ; CODE XREF: start+DF9j
                xor     bl, bl
                bt      eax, 0Eh
                adc     bl, bl
                bt      eax, 0Fh
                adc     bl, 0
                cmp     bl, 2
                jge     short loc_401E36
                mov     byte ptr [edi+25h], 0A2h
                mov     bl, al
                and     bl, 7
                shl     bl, 3
                mov     [edi+2Eh], bl
                mov     dword ptr [edi+26h], 20001h
                mov     dword ptr [edi+2Ah], 2
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401E36:                             ; CODE XREF: start+E12j
                jmp     loc_4024C7
; ---------------------------------------------------------------------------

loc_401E3B:                             ; CODE XREF: start+DEAj
                                        ; start+DF4j ...
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 0AFh
                jnz     short loc_401E62
                mov     byte ptr [edi+25h], 0A3h
                mov     dword ptr [edi+26h], 3
                mov     dword ptr [edi+2Ah], 100201h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401E62:                             ; CODE XREF: start+E49j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 0BCh
                jnz     short loc_401E89
                mov     byte ptr [edi+25h], 0A4h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 41h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401E89:                             ; CODE XREF: start+E70j
                mov     ebx, eax
                and     ebx, 0E7h
                cmp     ebx, 0A3h
                jnz     short loc_401EB8
                mov     byte ptr [edi+25h], 0A5h
                mov     dword ptr [edi+26h], 3
                mov     dword ptr [edi+2Ah], 200h
                cmp     al, 0A3h
                jz      short loc_401EB3
                or      dword ptr [edi+2Ah], 2

loc_401EB3:                             ; CODE XREF: start+EADj
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401EB8:                             ; CODE XREF: start+E97j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 0B0h
                jnz     short loc_401EE4
                mov     byte ptr [edi+25h], 0A6h
                mov     dword ptr [edi+26h], 7
                mov     dword ptr [edi+2Ah], 46h
                and     al, 1
                mov     [edi+22h], al
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401EE4:                             ; CODE XREF: start+EC6j
                mov     ebx, eax
                and     ebx, 0F0h
                cmp     ebx, 90h
                jnz     short loc_401F6F
                test    ah, 38h
                jnz     short loc_401F6F
                mov     byte ptr [edi+25h], 0A7h
                mov     dword ptr [edi+2Ah], 2
                mov     bh, al
                mov     bl, [edi+26h]
                and     bh, 0Fh
                jnz     short loc_401F1A
                mov     dword ptr [edi+26h], 100000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401F1A:                             ; CODE XREF: start+F0Cj
                xor     [edi+26h], bl
                mov     bl, bh
                and     bl, 0Bh
                cmp     bl, 2
                jnz     short loc_401F2E
                or      dword ptr [edi+26h], 200h

loc_401F2E:                             ; CODE XREF: start+F25j
                mov     bl, bh
                and     bl, 0Dh
                cmp     bl, 4
                jnz     short loc_401F3C
                or      dword ptr [edi+26h], 40h

loc_401F3C:                             ; CODE XREF: start+F36j
                mov     bl, bh
                cmp     bl, 0Ah
                jz      short loc_401F63
                or      dword ptr [edi+26h], 80h
                test    al, 4
                jz      short loc_401F5E
                or      dword ptr [edi+26h], 100000h
                test    bh, 2
                jz      short loc_401F5E
                or      dword ptr [edi+26h], 40h

loc_401F5E:                             ; CODE XREF: start+F4Cj
                                        ; start+F58j
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401F63:                             ; CODE XREF: start+F41j
                mov     dword ptr [edi+26h], 80000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_401F6F:                             ; CODE XREF: start+EF2j
                                        ; start+EF7j
                mov     ebx, eax
                and     ebx, 0FDh
                cmp     ebx, 20h
                jnz     short loc_401FB9
                mov     bl, al
                and     bl, 18h
                cmp     bl, 8
                jz      short loc_401FB9
                mov     byte ptr [edi+25h], 0A8h
                mov     dword ptr [edi+26h], 1
                mov     dword ptr [edi+2Ah], 2000h
                test    al, 2
                jz      short loc_401FAA
                xor     dword ptr [edi+26h], 2001h
                xor     dword ptr [edi+2Ah], 2001h

loc_401FAA:                             ; CODE XREF: start+F9Aj
                mov     al, ah
                and     al, 7
                shl     al, 3
                mov     [edi+16h], al
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401FB9:                             ; CODE XREF: start+F7Aj
                                        ; start+F84j
                mov     ebx, eax
                and     ebx, 0FDh
                cmp     ebx, 21h
                jnz     short loc_401FF9
                mov     byte ptr [edi+25h], 0A9h
                mov     dword ptr [edi+26h], 1
                mov     dword ptr [edi+2Ah], 4000h
                test    al, 2
                jz      short loc_401FEA
                xor     dword ptr [edi+26h], 4001h
                xor     dword ptr [edi+2Ah], 4001h

loc_401FEA:                             ; CODE XREF: start+FDAj
                mov     al, ah
                and     al, 7
                shl     al, 3
                mov     [edi+16h], al
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_401FF9:                             ; CODE XREF: start+FC4j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 2
                jnz     short loc_40201D
                mov     byte ptr [edi+25h], 0AAh
                mov     dword ptr [edi+2Ah], 1
                mov     dword ptr [edi+26h], 2
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_40201D:                             ; CODE XREF: start+1004j
                mov     ebx, eax
                cmp     ebx, 1
                jnz     short loc_402050
                mov     bl, ah
                and     bl, 28h
                jnz     short loc_402050
                mov     bh, ah
                and     bh, 0C0h
                cmp     bh, 0C0h
                jz      loc_4024C7
                mov     byte ptr [edi+25h], 0ABh
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 10000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_402050:                             ; CODE XREF: start+1022j
                                        ; start+1029j
                mov     ebx, eax
                cmp     ebx, 1
                jnz     short loc_402086
                mov     bl, ah
                and     bl, 28h
                cmp     bl, 8
                jnz     short loc_402086
                mov     bh, ah
                and     bh, 0C0h
                cmp     bh, 0C0h
                jz      loc_4024C7
                mov     byte ptr [edi+25h], 0ACh
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 10000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_402086:                             ; CODE XREF: start+1055j
                                        ; start+105Fj
                mov     ebx, eax
                test    bl, 0FFh
                jnz     short loc_4020AB
                mov     bl, ah
                and     bl, 28h
                jnz     short loc_4020AB
                mov     byte ptr [edi+25h], 0ADh
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 10000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_4020AB:                             ; CODE XREF: start+108Bj
                                        ; start+1092j
                mov     ebx, eax
                cmp     bl, 1
                jnz     short loc_4020D3
                mov     bl, ah
                and     bl, 28h
                cmp     bl, 20h
                jnz     short loc_4020D3
                mov     byte ptr [edi+25h], 0AEh
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 10000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_4020D3:                             ; CODE XREF: start+10B0j
                                        ; start+10BAj
                mov     ebx, eax
                and     ebx, 0FFh
                jnz     short loc_4020FE
                mov     bl, ah
                and     bl, 28h
                cmp     bl, 8
                jnz     short loc_4020FE
                mov     byte ptr [edi+25h], 0AFh
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 10000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_4020FE:                             ; CODE XREF: start+10DBj
                                        ; start+10E5j
                mov     ebx, eax
                test    ebx, 0FFh
                jnz     short loc_402129
                mov     bl, ah
                and     bl, 30h
                cmp     bl, 20h
                jnz     short loc_402129
                mov     byte ptr [edi+25h], 0B0h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 40h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_402129:                             ; CODE XREF: start+1106j
                                        ; start+1110j
                mov     ebx, eax
                cmp     bl, 0C7h
                jnz     short loc_402147
                mov     byte ptr [edi+25h], 0B1h
                mov     dword ptr [edi+26h], 0Eh
                mov     dword ptr [edi+2Ah], 4Eh
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_402147:                             ; CODE XREF: start+112Ej
                mov     ebx, eax
                or      bl, 1
                cmp     bl, 0C1h
                jnz     short loc_402168
                mov     byte ptr [edi+25h], 0B2h
                mov     dword ptr [edi+26h], 3
                mov     dword ptr [edi+2Ah], 2
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_402168:                             ; CODE XREF: start+114Fj
                mov     ebx, eax
                and     ebx, 38FFh
                cmp     ebx, 3801h
                jnz     short loc_40218F
                mov     byte ptr [edi+25h], 0B3h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 10000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_40218F:                             ; CODE XREF: start+1176j
                mov     ebx, eax
                and     ebx, 0F0h
                cmp     ebx, 40h
                jnz     short loc_402212
                mov     byte ptr [edi+25h], 0B4h
                mov     dword ptr [edi+26h], 0
                and     al, 0Eh
                jnz     short loc_4021B4
                or      dword ptr [edi+26h], 100000h
                jmp     short loc_402202
; ---------------------------------------------------------------------------

loc_4021B4:                             ; CODE XREF: start+11A9j
                cmp     al, 2
                jnz     short loc_4021C1
                or      dword ptr [edi+26h], 200h
                jmp     short loc_402202
; ---------------------------------------------------------------------------

loc_4021C1:                             ; CODE XREF: start+11B6j
                cmp     al, 4
                jnz     short loc_4021CE
                mov     dword ptr [edi+26h], 40h
                jmp     short loc_402202
; ---------------------------------------------------------------------------

loc_4021CE:                             ; CODE XREF: start+11C3j
                cmp     al, 6
                jnz     short loc_4021DB
                mov     dword ptr [edi+26h], 240h
                jmp     short loc_402202
; ---------------------------------------------------------------------------

loc_4021DB:                             ; CODE XREF: start+11D0j
                cmp     al, 8
                jnz     short loc_4021E8
                mov     dword ptr [edi+26h], 80h
                jmp     short loc_402202
; ---------------------------------------------------------------------------

loc_4021E8:                             ; CODE XREF: start+11DDj
                cmp     al, 0Ah
                jnz     short loc_4021F3
                mov     dword ptr [edi+26h], 80000h

loc_4021F3:                             ; CODE XREF: start+11EAj
                mov     dword ptr [edi+26h], 100080h
                test    al, 2
                jz      short loc_402202
                or      dword ptr [edi+26h], 40h

loc_402202:                             ; CODE XREF: start+11B2j
                                        ; start+11BFj ...
                or      dword ptr [edi+26h], 3
                mov     dword ptr [edi+2Ah], 1
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_402212:                             ; CODE XREF: start+119Aj
                mov     ebx, eax
                and     ebx, 0FDh
                cmp     ebx, 24h
                jnz     short loc_40225C
                mov     bl, ah
                and     bl, 38h
                cmp     bl, 10h
                jle     short loc_40225C
                mov     byte ptr [edi+25h], 0B5h
                mov     dword ptr [edi+26h], 1
                mov     dword ptr [edi+2Ah], 8000h
                test    al, 2
                jz      short loc_40224D
                xor     dword ptr [edi+26h], 8001h
                xor     dword ptr [edi+2Ah], 8001h

loc_40224D:                             ; CODE XREF: start+123Dj
                mov     al, ah
                and     al, 7
                shl     al, 3
                mov     [edi+16h], al
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40225C:                             ; CODE XREF: start+121Dj
                                        ; start+1227j
                mov     ebx, eax
                and     ebx, 0F6h
                cmp     ebx, 0A4h
                jnz     short loc_402292
                mov     byte ptr [edi+25h], 0E1h
                mov     dword ptr [edi+2Ah], 2
                mov     dword ptr [edi+26h], 3
                and     al, 1
                jz      loc_4024DA
                or      dword ptr [edi+26h], 1000000h
                jmp     loc_4024D2
; ---------------------------------------------------------------------------

loc_402292:                             ; CODE XREF: start+126Aj
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 0BAh
                jnz     short loc_4022D6
                mov     bl, ah
                and     bl, 38h
                cmp     bl, 20h
                jl      short loc_4022D6
                mov     byte ptr [edi+25h], 0E2h
                mov     dword ptr [edi+26h], 2
                mov     dword ptr [edi+2Ah], 202h
                mov     bx, ax
                and     bh, 38h
                cmp     bx, 20BAh
                jnz     short loc_4022CF
                xor     dword ptr [edi+2Ah], 2

loc_4022CF:                             ; CODE XREF: start+12C9j
                mov     al, 0
                jmp     loc_4024DA
; ---------------------------------------------------------------------------

loc_4022D6:                             ; CODE XREF: start+12A0j
                                        ; start+12AAj
                mov     byte ptr [edi+10h], 2
                dec     esi
                mov     ebx, eax
                and     ebx, 0F0h
                cmp     ebx, 80h
                jnz     short loc_40235F
                mov     byte ptr [edi+25h], 0C1h
                mov     dword ptr [edi+2Ah], 40000h
                mov     dword ptr [edi+26h], 0
                and     al, 0Eh
                jnz     short loc_40230A
                or      dword ptr [edi+26h], 100000h
                jmp     short loc_402358
; ---------------------------------------------------------------------------

loc_40230A:                             ; CODE XREF: start+12FFj
                cmp     al, 2
                jnz     short loc_402317
                or      dword ptr [edi+26h], 200h
                jmp     short loc_402358
; ---------------------------------------------------------------------------

loc_402317:                             ; CODE XREF: start+130Cj
                cmp     al, 4
                jnz     short loc_402324
                mov     dword ptr [edi+26h], 40h
                jmp     short loc_402358
; ---------------------------------------------------------------------------

loc_402324:                             ; CODE XREF: start+1319j
                cmp     al, 6
                jnz     short loc_402331
                mov     dword ptr [edi+26h], 240h
                jmp     short loc_402358
; ---------------------------------------------------------------------------

loc_402331:                             ; CODE XREF: start+1326j
                cmp     al, 8
                jnz     short loc_40233E
                mov     dword ptr [edi+26h], 80h
                jmp     short loc_402358
; ---------------------------------------------------------------------------

loc_40233E:                             ; CODE XREF: start+1333j
                cmp     al, 0Ah
                jnz     short loc_402349
                mov     dword ptr [edi+26h], 80000h

loc_402349:                             ; CODE XREF: start+1340j
                mov     dword ptr [edi+26h], 100080h
                test    al, 2
                jz      short loc_402358
                or      dword ptr [edi+26h], 40h

loc_402358:                             ; CODE XREF: start+1308j
                                        ; start+1315j ...
                mov     al, 1
                jmp     loc_4024DF
; ---------------------------------------------------------------------------

loc_40235F:                             ; CODE XREF: start+12E9j
                mov     ebx, eax
                and     ebx, 0C6h
                cmp     ebx, 80h
                jnz     short loc_4023AF
                mov     ebx, eax
                and     bl, 38h
                cmp     bl, 30h
                jge     short loc_4023AF
                cmp     bl, 20h
                jl      short loc_4023AF
                mov     byte ptr [edi+25h], 81h
                mov     bl, al
                and     bl, 38h
                mov     [edi+2Eh], bl
                mov     dword ptr [edi+26h], 800h
                mov     dword ptr [edi+2Ah], 20000h
                test    al, 1
                jnz     short loc_4023AA
                xor     dword ptr [edi+26h], 20800h
                xor     dword ptr [edi+2Ah], 20800h

loc_4023AA:                             ; CODE XREF: start+139Aj
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4023AF:                             ; CODE XREF: start+136Dj
                                        ; start+1377j ...
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 6
                jnz     short loc_4023D3
                mov     byte ptr [edi+25h], 82h
                mov     dword ptr [edi+26h], 0
                mov     dword ptr [edi+2Ah], 2000h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_4023D3:                             ; CODE XREF: start+13BAj
                mov     ebx, eax
                and     ebx, 0F8h
                cmp     ebx, 0C8h
                jnz     short loc_402402
                and     al, 7
                shl     al, 3
                mov     [edi+16h], al
                mov     byte ptr [edi+25h], 83h
                mov     dword ptr [edi+26h], 1
                mov     dword ptr [edi+2Ah], 1
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_402402:                             ; CODE XREF: start+13E1j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 8
                jnz     short loc_402426
                mov     byte ptr [edi+25h], 84h
                mov     dword ptr [edi+26h], 0
                mov     dword ptr [edi+2Ah], 10000h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_402426:                             ; CODE XREF: start+140Dj
                mov     ebx, eax
                and     ebx, 0FCh
                cmp     ebx, 30h
                jnz     short loc_40245E
                mov     byte ptr [edi+25h], 85h
                test    al, 3
                jnz     short loc_40244E
                mov     dword ptr [edi+26h], 100000Ch
                mov     dword ptr [edi+2Ah], 10000h
                jmp     loc_4024CF
; ---------------------------------------------------------------------------

loc_40244E:                             ; CODE XREF: start+1439j
                mov     dword ptr [edi+26h], 1010000h
                mov     dword ptr [edi+2Ah], 0Ch
                jmp     short loc_4024CF
; ---------------------------------------------------------------------------

loc_40245E:                             ; CODE XREF: start+1431j
                mov     ebx, eax
                and     ebx, 0FEh
                cmp     ebx, 34h
                jnz     short loc_40247F
                mov     byte ptr [edi+25h], 86h
                mov     dword ptr [edi+26h], 0FFFFFFFFh
                mov     dword ptr [edi+2Ah], 0FFFFFFFFh
                jmp     short loc_4024CF
; ---------------------------------------------------------------------------

loc_40247F:                             ; CODE XREF: start+1469j
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 0A2h
                jnz     short loc_4024A3
                mov     byte ptr [edi+25h], 87h
                mov     dword ptr [edi+26h], 10000h
                mov     dword ptr [edi+2Ah], 0Ch
                jmp     short loc_4024CF
; ---------------------------------------------------------------------------

loc_4024A3:                             ; CODE XREF: start+148Dj
                mov     ebx, eax
                and     ebx, 0FFh
                cmp     ebx, 0AAh
                jnz     short loc_4024C7
                mov     byte ptr [edi+25h], 88h
                mov     dword ptr [edi+26h], 0FFFFFFFFh
                mov     dword ptr [edi+2Ah], 0FFFFFFFFh
                jmp     short loc_4024CF
; ---------------------------------------------------------------------------

loc_4024C7:                             ; CODE XREF: start+D6j
                                        ; start+DFj ...
                popa
                mov     eax, 1
                stc
                retn
; ---------------------------------------------------------------------------

loc_4024CF:                             ; CODE XREF: start+59Bj
                                        ; start+60Fj ...
                popa
                clc
                retn
; ---------------------------------------------------------------------------

loc_4024D2:                             ; CODE XREF: start+B7j
                                        ; start+120j ...
                call    sub_4024E7
                popa
                clc
                retn
; ---------------------------------------------------------------------------

loc_4024DA:                             ; CODE XREF: start+4A4j
                                        ; start+4F2j ...
                call    sub_4024E7

loc_4024DF:                             ; CODE XREF: start+9F6j
                                        ; start+A70j ...
                call    sub_40258F
                popa
                clc
                retn
DASM            endp


; --------------- S U B R O U T I N E ---------------------------------------


sub_4024E7      proc near               ; CODE XREF: start+584p
                                        ; start+14D2p ...
                push    eax
                mov     byte ptr [edi+13h], 1
                push    eax
                and     ah, 0C0h
                mov     [edi+14h], ah
                pop     eax
                push    eax
                and     ah, 38h
                mov     [edi+16h], ah
                pop     eax
                push    eax
                and     ah, 7
                mov     [edi+15h], ah
                pop     eax
                cmp     byte ptr [edi+1Dh], 1
                jz      short loc_40256B
                cmp     byte ptr [edi+14h], 0C0h
                jz      short loc_40253D
                cmp     byte ptr [edi+15h], 4
                jnz     short loc_40253D
                push    eax
                lodsb
                mov     byte ptr [edi+17h], 1
                push    eax
                and     al, 0C0h
                mov     [edi+18h], al
                pop     eax
                push    eax
                and     al, 38h
                mov     [edi+19h], al
                pop     eax
                and     al, 7
                mov     [edi+1Ah], al
                cmp     al, 5
                jnz     short loc_40253C
                cmp     byte ptr [edi+14h], 0
                jnz     short loc_40253C
                pop     eax
                jmp     short loc_402553
; ---------------------------------------------------------------------------

loc_40253C:                             ; CODE XREF: sub_4024E7+4Aj
                                        ; sub_4024E7+50j
                pop     eax

loc_40253D:                             ; CODE XREF: sub_4024E7+27j
                                        ; sub_4024E7+2Dj
                cmp     byte ptr [edi+14h], 40h
                jnz     short loc_40254D

loc_402543:                             ; CODE XREF: sub_4024E7+88j
                lodsb
                mov     [edi+4], al
                mov     byte ptr [edi+11h], 1
                jmp     short loc_402569
; ---------------------------------------------------------------------------

loc_40254D:                             ; CODE XREF: sub_4024E7+5Aj
                cmp     byte ptr [edi+14h], 80h
                jnz     short loc_40255D

loc_402553:                             ; CODE XREF: sub_4024E7+53j
                                        ; sub_4024E7+80j
                lodsd
                mov     [edi+4], eax
                mov     byte ptr [edi+11h], 4
                jmp     short loc_402569
; ---------------------------------------------------------------------------

loc_40255D:                             ; CODE XREF: sub_4024E7+6Aj
                cmp     byte ptr [edi+14h], 0
                jnz     short loc_402569
                cmp     byte ptr [edi+15h], 5
                jz      short loc_402553

loc_402569:                             ; CODE XREF: sub_4024E7+64j
                                        ; sub_4024E7+74j ...
                pop     eax
                retn
; ---------------------------------------------------------------------------

loc_40256B:                             ; CODE XREF: sub_4024E7+21j
                cmp     byte ptr [edi+14h], 40h
                jz      short loc_402543
                cmp     byte ptr [edi+14h], 80h
                jz      short loc_402583
                cmp     byte ptr [edi+14h], 0
                jnz     short loc_40258D
                cmp     byte ptr [edi+15h], 6
                jnz     short loc_40258D

loc_402583:                             ; CODE XREF: sub_4024E7+8Ej
                lodsw
                mov     [edi+4], ax
                mov     byte ptr [edi+11h], 2

loc_40258D:                             ; CODE XREF: sub_4024E7+94j
                                        ; sub_4024E7+9Aj
                pop     eax
                retn
sub_4024E7      endp


; --------------- S U B R O U T I N E ---------------------------------------


sub_40258F      proc near               ; CODE XREF: start+14DFp
                or      al, al
                jnz     short loc_40259C
                lodsb
                mov     [edi+0Ah], al
                mov     byte ptr [edi+12h], 1
                retn
; ---------------------------------------------------------------------------

loc_40259C:                             ; CODE XREF: sub_40258F+2j
                cmp     byte ptr [edi+1Ch], 1
                jnz     short loc_4025AD
                lodsw
                mov     [edi+0Ah], ax
                mov     byte ptr [edi+12h], 2
                retn
; ---------------------------------------------------------------------------

loc_4025AD:                             ; CODE XREF: sub_40258F+11j
                lodsd
                mov     [edi+0Ah], eax
                mov     byte ptr [edi+12h], 4
                retn
sub_40258F      endp    
sizeDASM	=	$ - DASM

GetLen:         
                pusha
                xor     eax, eax
                cmp     byte ptr [edi+1Eh], 0
                jz      short loc_40100B
                inc     eax

loc_40100B:                             ; CODE XREF: start+8j
                cmp     byte ptr [edi+1Dh], 0
                jz      short loc_401012
                inc     eax

loc_401012:                             ; CODE XREF: start+Fj
                cmp     byte ptr [edi+1Ch], 0
                jz      short loc_401019
                inc     eax

loc_401019:                             ; CODE XREF: start+16j
                cmp     byte ptr [edi+1Fh], 0
                jz      short loc_401020
                inc     eax

loc_401020:                             ; CODE XREF: start+1Dj
                cmp     byte ptr [edi+20h], 0
                jz      short loc_401027
                inc     eax

loc_401027:                             ; CODE XREF: start+24j
                mov     edx, eax
                push    eax
                xor     ecx, ecx
                mov     cl, [edi+10h]

loc_40102F:                             ; CODE XREF: start+30j
                inc     edx
                dec		ecx
                jnz    loc_40102F
                pop     eax
                mov     eax, edx
                cmp     byte ptr [edi+17h], 1
                jnz     short loc_40103C
                inc     eax

loc_40103C:                             ; CODE XREF: start+39j
                cmp     byte ptr [edi+11h], 0
                jz      short loc_401048
                add     al, [edi+11h]
                adc     ah, 0

loc_401048:                             ; CODE XREF: start+40j
                cmp     byte ptr [edi+12h], 0
                jz      short loc_401054
                add     al, [edi+12h]
                adc     ah, 0

loc_401054:                             ; CODE XREF: start+4Cj
                mov 	[esp].popa_eax, eax
				popa
                retn

VPE_asm: 
		pusha
		mov		ebx, [esp+32+4]
		mov		edi, [esp+32+4+4]
		push	ebx
		call	VPE_JmpFix
		pop		ebx
		mov		edx, 4 ptr [ebp].CNum 
		xor		ecx, ecx
_Asm:   
		xchg	ebx, edi
		call	GetLen 
		add		ecx, eax
		xchg	ebx, edi
		call	_Assm
		add		edi, eax
		mov		ebx, 4 ptr [ebx]._NextrStr                 
		or		ebx, ebx
		jz		_OOK1
		jmp		_Asm
_OOK1:
		mov		[esp].popa_ecx, ecx
		popa
		ret    
_Assm:
db 060h, 080h, 07Bh, 01Eh, 000h, 074h, 003h, 0B0h, 0F0h, 0AAh, 080h, 07Bh
db 01Dh, 000h, 074h, 003h, 0B0h, 067h, 0AAh, 080h, 07Bh, 01Ch, 000h, 074h
db 003h, 0B0h, 066h, 0AAh, 080h, 07Bh, 01Fh, 000h, 074h, 004h, 08Ah, 043h
db 01Fh, 0AAh, 080h, 07Bh, 020h, 000h, 074h, 004h, 08Ah, 043h, 020h, 0AAh
db 08Bh, 003h, 051h, 033h, 0C9h, 08Ah, 04Bh, 010h, 0AAh, 0C1h, 0E8h, 008h
db 0E2h, 0FAh, 059h, 080h, 07Bh, 017h, 001h, 075h, 00Ah, 08Ah, 043h, 018h
db 00Ah, 043h, 019h, 00Ah, 043h, 01Ah, 0AAh, 080h, 07Bh, 011h, 000h, 074h
db 00Ch, 056h, 08Dh, 073h, 004h, 02Bh, 0C9h, 08Ah, 04Bh, 011h, 0F3h, 0A4h
db 05Eh, 080h, 07Bh, 012h, 000h, 074h, 00Ch, 056h, 08Dh, 073h, 00Ah, 02Bh
db 0C9h, 08Ah, 04Bh, 012h, 0F3h, 0A4h, 05Eh, 061h, 0C3h










